function [c,k,theta,y,yd,i,g,gy,cy,iy,ferror]=MBK(eps,theta0,k0,css,kss,thetass,nobs,param)

% [Copyright: J. Ruiz]


A=param(1);
beta=param(2);
sigma=param(3);
n=param(4);
delta=param(5);
alpha=param(6);
tauc=param(7);
tauy=param(8);
rho=param(9);
sigmae=param(10);





%  Computing A, B, C, D, F 

MA=[(1-alpha)*(((1+n)/beta)-1+delta)         ((1+n)/beta)*sigma;
          (1+n)                                                      0 ];

MB=[ 0                         ((1+n)/beta)*sigma;
           (1+n)/beta         -(1+tauc)*css/kss ];

MC=[ rho*(((1+n)/beta)-1+delta);
           (((1+n)/beta)-1+delta)/alpha];

MD=inv(MA)*MB;

MF=inv(MA)*MC;


%  Computing   m ,  Q

  [kvec,keig]=eig(MD);
  
  keig2=diag(keig);

  [keig3,kord]=sort(abs(keig2));

  if keig3(1)>1
     'error - no solution'
  end

  if keig3(2)<1
     'error - multiple solutions'
  end

  keig4=keig2(kord);

  Mlambda=diag(keig4);

  MM=kvec(:,kord);

  Mm=inv(MM);

  MQ=Mm*MF;


%  Computing paths for physical capital, shock and consumption

G=(MQ(1)-((rho-Mlambda(1,1))/(rho-Mlambda(2,2)))*(MQ(2)*Mm(1,2)/Mm(2,2)))/(Mm(1,1)-Mm(1,2)*Mm(2,1)/Mm(2,2));

MT=[Mlambda(1,1)        G  ;
         0                             rho];    %  matriz de transicion de estados

MI=[0;1];     %   innovations effects matrix

MC=[-Mm(2,1)/Mm(2,2)        (MQ(2)/Mm(2,2))/(rho-Mlambda(2,2))];     %   control matrix


%%%%%%%%%%%%


estad0=[log(k0/kss); log(theta0/thetass)];


ct=[];
estad=[];

for t=1:nobs
    
   cte=MC*estad0;
   ct=[ct; cte];
   estade=MT*estad0+MI*eps(t);
   estad=[estad; estade'];
   estad0=estade;
   
end

c=[];
k=[];
theta=[];
y=[];
i=[];  
r=[];
g=[];
gy=[];
cy=[];
yd=[];
ferror=[];

thetaant=theta0;
kant=k0;

for t=1:nobs

    ce=css*exp(ct(t));
    c=[c; ce];

    ke=kant;
    k=[k; ke];
    kant=kss*exp(estad(t,1));

    thetae=thetaant;
    theta=[theta; thetae];
    thetaant=thetass*exp(estad(t,2));

    ye=A*thetae*ke^alpha;
    y=[y; ye];

    re=alpha*(ye/ke)-delta;
    r=[r ; re];
    
    ge=tauy*ye+tauc*ce;
    g=[g; ge];
    
    gye=ge/ye;
    gy=[gy; gye];
    
    cye=ce/ye;
    cy=[cy; cye];
    
    yde=(1-tauy)*ye;
    yd=[yd; yde];
    
end


    
for t=1:nobs-1

      ie=(1+n)*k(t+1)-(1-delta)*k(t);
      i=[i  ; ie] ;
       
  
      ferrore=(c(t+1)^(-sigma))*((1-tauy)*alpha*A*theta(t+1)*...
          (k(t+1)^(alpha-1))+(1-delta))-((1+n)/beta)*(c(t)^(-sigma));
      ferror=[ferror; ferrore];
end

iy=i./y(1:nobs-1);