function [c,k,theta,y,yd,i,g,gy,cy,iy,ferror]=MLSIMS(eps,theta0,k0,css,kss,thetass,nobs,param)

% [Copyright: J. Ruiz]


A=param(1);
beta=param(2);
sigma=param(3);
n=param(4);
delta=param(5);
alpha=param(6);
tauc=param(7);
tauy=param(8);
rho=param(9);
sigmae=param(10);


    lkss=log(kss);
    lcss=log(css);
    lthetss=log(thetass);

    
    x=[lkss lkss lcss lcss lthetss lthetss 0 0]';

    J=jacobian('ss_lsims',x,param); % transition matrix
    MA=[J(1,1) J(1,3) J(1,5);
        J(2,1) J(2,3) J(2,5);
        J(3,1) J(3,3) J(3,5)];
    MB=[J(1,2) J(1,4) J(1,6);
        J(2,2) J(2,4) J(2,6);
        J(3,2) J(3,4) J(3,6)];
    Meps=-[J(1,7);
          J(2,7);
          J(3,7)];
    Minn=-[J(1,8);
          J(2,8);
          J(3,8)];
    MG=-inv(MA)*MB;
    
    [V,D]=eig(MG');

    ZI=[];
    ZR=[];
    AVALR=[];AVALI=[];
    for j=1:length(V)
        ZR=[ZR,real(V(:,j))];
        ZI=[ZI,imag(V(:,j))];
        AVALR=[AVALR;real(D(j,j))];
        AVALI=[AVALI;imag(D(j,j))];
    end

    ZZ=[];
    contr=0.0;
for j=1:length(V)
    if abs(AVALI(j))>0.000001
       if abs((AVALR(j)^2+AVALI(j)^2)^(0.5))>=1/beta
       
	     if contr~=abs((AVALR(j)^2+AVALI(j)^2)^(0.5))
                         ZZ=[ZZ ZR(:,j) ZI(:,j)];
	     end
	     contr=abs((AVALR(j)^2+AVALI(j)^2)^(0.5));             
       end
       elseif abs(AVALR(j))>=1/beta
           ZZ=[ZZ,ZR(:,j)];
    end
end


ZZ=ZZ';

   
%  initial conditions


lc0=lcss+(-1/ZZ(2))*(ZZ(1)*(log(k0)-lkss)+ZZ(3)*(log(theta0)));
c0=exp(lc0);
c=[];c=[c; c0];
k=[];k=[k; k0];
theta=[];theta=[theta; theta0];
y=[];y0=theta0*A*(k0^alpha);y=[y;y0];
i=[];  
r=[];r0=alpha*(y0/k0)-delta; r=[r;r0];
g=[];g0=tauy*y0+tauc*c0; g=[g;g0];
gy=[]; gy0=g0/y0; gy=[gy;gy0];
cy=[]; cy0=c0/y0; cy=[cy;cy0];
iy=[];
yd=[]; yd0=(1-tauy)*y0; yd=[yd;yd0];
ferror=[];


for t=1:nobs

    k1=(1/(1+n))*((1-tauy)*theta0*A*(k0^alpha)+(1-delta)*k0-(1+tauc)*c0);
    theta1=exp(rho*log(theta0)+eps(t));
    lc1=lcss+(-1/ZZ(2))*(ZZ(1)*(log(k1)-lkss)+ZZ(3)*(log(theta1)));
    c1=exp(lc1);
    y1=theta1*A*(k1^alpha);y=[y;y1];
    i1=(1+n)*k1-(1-delta)*k0;i=[i;i1];
    iy1=i1/y1; iy=[iy;iy1];
    ferror1=(c1^(-sigma))*((1-tauy)*alpha*A*theta1*...
          (k1^(alpha-1))+(1-delta))-((1+n)/beta)*(c0^(-sigma));
    ferror=[ferror;ferror1];
        
    r1=alpha*(y1/k1)-delta; r=[r;r1];
    g1=tauy*y1+tauc*c1; g=[g;g1];
    gy1=g1/y1; gy=[gy;gy1];
    cy1=c1/y1; cy=[cy;cy1];
    yd1=(1-tauy)*y1; yd=[yd;yd1];
    k0=k1;c0=c1;theta0=theta1;
    k=[k;k0];c=[c;c0];theta=[theta;theta0];
    
end
    
