function [c,k,theta,y,yd,i,g,gy,cy,iy,ferror]=MUHLIG(eps,theta0,k0,css,kss,thetass,nobs,param)

% [Copyright: J. Ruiz]


A=param(1);
beta=param(2);
sigma=param(3);
n=param(4);
delta=param(5);
alpha=param(6);
tauc=param(7);
tauy=param(8);
rho=param(9);
sigmae=param(10);


    lkss=log(kss);
    lcss=log(css);
    lthetss=log(thetass);

    x=[lkss lkss lcss lcss lthetss lthetss 0 0]';

    J=jacobian('ss_lsims',x,param); % transition matrix
    alpha1=J(1,4);
    alpha2=J(1,1);
    alpha3=J(1,6);
    alpha4=J(1,2);
    beta1=J(2,4);
    beta2=J(2,1);
    beta3=J(2,5);
    beta4=J(2,3);
    etakk1=((alpha1*beta2-beta1*alpha2-beta4*alpha4)+...
        ((alpha1*beta2-beta1*alpha2-beta4*alpha4)^2-4*beta4*alpha2*...
        beta1*alpha4)^0.5)/(2*beta4*alpha2);
    etakk2=((alpha1*beta2-beta1*alpha2-beta4*alpha4)-...
        ((alpha1*beta2-beta1*alpha2-beta4*alpha4)^2-4*beta4*alpha2*...
        beta1*alpha4)^0.5)/(2*beta4*alpha2);
    if abs(etakk1)<1
        etakk=etakk1;
    else
        etakk=etakk2;
    end
    etack=-(alpha2*etakk+alpha4)/alpha1;
    etakt=((beta1+rho*beta4)*alpha3-alpha1*beta3*rho)/...
        (beta2*alpha1+beta4*alpha1*etack-(beta1+rho*beta4)*alpha2);
    etact=-(alpha3+alpha2*etakt)/alpha1;
    
   
%  initial conditions


lc0=lcss+etack*(log(k0)-lkss)+etact*(log(theta0));
c0=exp(lc0);
c=[];c=[c; c0];
k=[];k=[k; k0];
theta=[];theta=[theta; theta0];
y=[];y0=theta0*A*(k0^alpha);y=[y;y0];
i=[];  
r=[];r0=alpha*(y0/k0)-delta; r=[r;r0];
g=[];g0=tauy*y0+tauc*c0; g=[g;g0];
gy=[]; gy0=g0/y0; gy=[gy;gy0];
cy=[]; cy0=c0/y0; cy=[cy;cy0];
iy=[];
yd=[]; yd0=(1-tauy)*y0; yd=[yd;yd0];
ferror=[];


for t=1:nobs

    lk1=lkss+etakk*(log(k0)-lkss)+etakt*log(theta0);k1=exp(lk1);
    theta1=exp(rho*log(theta0)+eps(t));
    lc1=lcss+etack*(log(k1)-lkss)+etact*(log(theta1));
    c1=exp(lc1);
    y1=theta1*A*(k1^alpha);y=[y;y1];
    i1=(1+n)*k1-(1-delta)*k0;i=[i;i1];
    iy1=i1/y1; iy=[iy;iy1];
    ferror1=(c1^(-sigma))*((1-tauy)*alpha*A*theta1*...
          (k1^(alpha-1))+(1-delta))-((1+n)/beta)*(c0^(-sigma));
    ferror=[ferror;ferror1];
        
    r1=alpha*(y1/k1)-delta; r=[r;r1];
    g1=tauy*y1+tauc*c1; g=[g;g1];
    gy1=g1/y1; gy=[gy;gy1];
    cy1=c1/y1; cy=[cy;cy1];
    yd1=(1-tauy)*y1; yd=[yd;yd1];
    k0=k1;c0=c1;theta0=theta1;
    k=[k;k0];c=[c;c0];theta=[theta;theta0];
    
end
    
